"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var crossvent = require("crossvent");
var env_1 = require("../env");
var util_1 = require("../util");
/**
 * Google analytics
 * @stable [10.10.2018]
 * @param args
 */
function gtag() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var dL = Reflect.get(window, 'dataLayer') || [];
    Reflect.set(window, 'dataLayer', dL);
    dL.push(arguments);
}
/**
 * @stable [14.11.2018]
 * @param {() => void} onInit
 * @param {string} extraClasses
 */
function bootstrapWebApp(onInit) {
    var extraClasses = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        extraClasses[_i - 1] = arguments[_i];
    }
    var ready = function () {
        util_1.addClassNameToBody.apply(void 0, ['rac'].concat(extraClasses));
        onInit();
    };
    if (env_1.ENV.prodMode && env_1.ENV.googleKey) {
        gtag('js', new Date());
        gtag('config', env_1.ENV.googleKey);
    }
    switch (document.readyState) {
        case 'loading':
        case 'interactive':
            // We cannot use DOMContentLoaded because fonts loading and UI blinking
            crossvent.add(window, 'load', ready);
            break;
        case 'complete':
            ready();
            break;
    }
}
exports.bootstrapWebApp = bootstrapWebApp;
//# sourceMappingURL=web-app.bootstrapper.js.map