"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var field_1 = require("../../field");
var util_1 = require("../../../util");
var BaseCheckbox = /** @class */ (function (_super) {
    __extends(BaseCheckbox, _super);
    function BaseCheckbox() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.inputId = util_1.uuid();
        return _this;
    }
    /**
     * @stable [31.08.2018]
     * @returns {IBaseCheckboxInputProps}
     */
    BaseCheckbox.prototype.getInputElementProps = function () {
        return __assign({}, _super.prototype.getInputElementProps.call(this), { id: this.inputId, type: 'checkbox', 
            /**
             * Needed for entity initializing
             * @stable [17.08.2018]
             */
            checked: this.displayValue, 
            /**
             * Only the manual changes
             * @stable [17.08.2018]
             */
            onChange: util_1.noop });
    };
    /**
     * @stable [31.08.2018]
     * @param {IBasicEvent} event
     */
    BaseCheckbox.prototype.onClick = function (event) {
        var props = this.props;
        // A workaround to any framework implementation
        this.onChangeManually(!this.value);
        if (props.onClick) {
            props.onClick(event);
        }
    };
    /**
     * @stable [31.08.2018]
     * @returns {JSX.Element}
     */
    BaseCheckbox.prototype.getLabelElement = function () {
        var props = this.props;
        return (React.createElement("label", { className: 'rac-field-label', htmlFor: this.inputId }, props.label ? this.t(props.label) : props.children));
    };
    return BaseCheckbox;
}(field_1.Field));
exports.BaseCheckbox = BaseCheckbox;
//# sourceMappingURL=base-checkbox.component.js.map