/// <reference types="react" />
import * as PropTypes from 'prop-types';
import { ChangeEventT, KeyboardEventT, BasicEventT, AnyT } from '../../../definitions.interface';
import { DateTimeLikeTypeT } from '../../../converter';
import { IDateFieldInternalProps, IDateFieldInternalState } from './datefield.interface';
import { BasicTextField } from '../textfield';
export declare class DateField extends BasicTextField<DateField, IDateFieldInternalProps, IDateFieldInternalState> {
    static defaultProps: IDateFieldInternalProps;
    static contextTypes: {
        muiTheme: PropTypes.Validator<object>;
    };
    constructor(props: IDateFieldInternalProps);
    onKeyEnter(event: KeyboardEventT): void;
    getRawValueFromEvent(event: ChangeEventT): DateTimeLikeTypeT;
    protected toSerializedValue(rawValue: DateTimeLikeTypeT): string;
    protected getInputAttachmentElement(): JSX.Element;
    protected getFieldMask(): Array<string | RegExp>;
    protected getFieldPattern(): string;
    protected toDisplayValue(value: AnyT): string;
    protected onClick(event: BasicEventT): void;
    /**
     * @stable [20.08.2018]
     * @param {Date} date
     */
    private onAccept;
    private readonly dialogDate;
    private readonly dialogWindow;
    private readonly fieldFormat;
    private readonly dateTimeSettings;
    private formatDate;
    private tryConvertToDate;
}
