import { AnyT, IKeyValue } from '../../../definitions.interface';
import { VueBaseComponent } from '../../base/vue-index';
import { VueCreateElementFactoryT, VueNodeT } from '../../../vue-definitions.interface';
import { IVueFieldTemplateComputedEntity, IVueFieldTemplateMethodsEntity, IVueFieldInputListenersEntity, IVueFieldStateEntity, IVueField } from './vue-field.interface';
export declare class VueField extends VueBaseComponent<IKeyValue, IVueFieldStateEntity> implements IVueField {
    value: AnyT;
    protected type: string;
    protected full: boolean;
    protected name: string;
    protected displayName: string;
    protected label: string;
    protected floatLabel: boolean;
    protected icon: string;
    protected placeholder: string;
    protected autoFocus: boolean;
    /**
     * @stable [17.11.2018]
     */
    constructor();
    /**
     * @stable [26.10.2018]
     */
    mounted(): void;
    /**
     * @stable [21.10.2018]
     * @param {VueCreateElementFactoryT} createElement
     * @returns {VueNodeT}
     */
    render(createElement: VueCreateElementFactoryT): VueNodeT;
    /**
     * @stable [17.11.2018]
     * @returns {Partial<HTMLInputElement>}
     */
    getInputBindings(): Partial<HTMLInputElement>;
    /**
     * @stable [17.11.2018]
     * @returns {string}
     */
    getFieldClassName(): string;
    /**
     * @stable [17.11.2018]
     * @returns {IVueFieldInputListenersEntity}
     */
    getInputListeners(): IVueFieldInputListenersEntity;
    /**
     * @stable [17.11.2018]
     * @returns {boolean}
     */
    isInputWrapperFull(): boolean;
    /**
     * @stable [17.11.2018]
     * @returns {boolean}
     */
    isFieldFull(): boolean;
    /**
     * @stable [27.11.2018]
     * @returns {string}
     */
    getInputWrapperClassName(): string;
    /**
     * @stable [17.11.2018]
     * @returns {AnyT}
     */
    getValue(): AnyT;
    /**
     * @stable [21.10.2018]
     * @param {AnyT} newValue
     */
    onChange(newValue: AnyT): void;
    /**
     * @stable [28.11.2018]
     * @param newValue
     * @param {AnyT} context
     */
    onChangeManually(newValue: any, context?: AnyT): void;
    /**
     * @stable [17.11.2018]
     * @returns {string}
     */
    protected getInputClassName(): string;
    /**
     * @stable [21.10.2018]
     * @returns {string}
     */
    protected getFieldAttachmentTemplate(): string;
    /**
     * @stable [18.11.2018]
     * @returns {string}
     */
    protected getInputAttachmentTemplate(): string;
    /**
     * @stable [22.10.2018]
     * @returns {string}
     */
    protected getLabelTemplate(): string;
    /**
     * @stable [24.11.2018]
     * @returns {boolean}
     */
    protected hasValue(): boolean;
    /**
     * @stable [26.10.2018]
     * @returns {IVueFieldTemplateComputedEntity}
     */
    protected getTemplateComputed(): IVueFieldTemplateComputedEntity;
    /**
     * @stable [17.11.2018]
     * @returns {AnyT}
     */
    protected getDisplayValue(): AnyT;
    /**
     * @stable [26.10.2018]
     * @returns {HTMLInputElement}
     */
    protected readonly inputEl: HTMLInputElement;
    /**
     * @stable [17.11.2018]
     * @returns {HTMLInputElement}
     */
    protected readonly inputWrapperEl: HTMLInputElement;
    /**
     * @stable [26.10.2018]
     */
    protected setFocus(): void;
    /**
     * @stable [27.11.2018]
     * @returns {IVueFieldTemplateMethodsEntity}
     */
    protected getTemplateMethods(): IVueFieldTemplateMethodsEntity;
}
