"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var textfield_1 = require("../textfield");
var keyboard_1 = require("../../keyboard");
var NumberField = /** @class */ (function (_super) {
    __extends(NumberField, _super);
    function NumberField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NumberField.prototype.getRawValueFromEvent = function (event) {
        return this.nc.number(_super.prototype.getRawValueFromEvent.call(this, event));
    };
    NumberField.prototype.getFieldPattern = function () {
        return _super.prototype.getFieldPattern.call(this) || this.numberSettings.uiPattern;
    };
    Object.defineProperty(NumberField.prototype, "numberSettings", {
        get: function () {
            return this.settings.number || {};
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [21.11.2018]
     * @returns {IKeyboardConfiguration}
     */
    NumberField.prototype.getKeyboardConfiguration = function () {
        return {
            layout: [keyboard_1.KEYBOARD_NUMERIC_LAYOUT],
        };
    };
    // We can't use number type because an input field throws an empty value on change if valid = false
    NumberField.defaultProps = {
        clearActionRendered: false,
    };
    return NumberField;
}(textfield_1.BasicTextField));
exports.NumberField = NumberField;
//# sourceMappingURL=numberfield.component.js.map