import { IEntity, ISubmitWrapper, IApiEntityWrapper } from '../../definitions.interface';
import { IBasicFormWrapperEntity, IFormWrapperEntity, IApiEntity, IComponent, IContainer, IEditableEntity, IContainerEntity } from '../../entities-definitions.interface';
import { IFormConfigurationWrapper, IFormConfiguration, IContainerConfiguration } from '../../configurations-definitions.interface';
/**
 * @stable [29.05.2018]
 */
export interface IFormProps extends IFormConfiguration, IFormWrapperEntity {
}
/**
 * @stable [29.05.2018]
 */
export interface IFormContainerEntity<TEntity extends IEntity> extends IContainerEntity, IBasicFormWrapperEntity<TEntity> {
}
/**
 * @stable [29.05.2018]
 */
export interface IFormContainerConfiguration extends IContainerConfiguration, IFormConfigurationWrapper {
}
/**
 * @stable [29.05.2018]
 */
export interface IFormContainerProps<TEntity extends IEntity = IEntity> extends IFormContainerEntity<TEntity>, IFormContainerConfiguration {
}
export interface IForm extends IComponent<IFormProps, {}>, IApiEntityWrapper<IApiEntity>, ISubmitWrapper<IApiEntity> {
}
export interface IFormContainer extends IContainer<IFormContainerProps>, ISubmitWrapper {
}
/**
 * @stable [29.05.2018]
 */
export declare const INITIAL_APPLICATION_FORM_STATE: IEditableEntity;
export declare const FORM_REF = "form";
export declare const FORM_SUBMIT_ACTION_TYPE = "form.submit";
export declare const FORM_SUBMIT_DONE_ACTION_TYPE: string;
export declare const FORM_SUBMIT_ERROR_ACTION_TYPE: string;
export declare const FORM_SUBMIT_FINISHED_ACTION_TYPE: string;
export declare const FORM_DESTROY_ACTION_TYPE = "form.destroy";
export declare const FORM_VALID_ACTION_TYPE = "form.valid";
export declare const FORM_RESET_ACTION_TYPE = "form.reset";
export declare const FORM_CHANGE_ACTION_TYPE = "form.change";
export declare const FORM_CLEAR_ACTION_TYPE = "form.clear";
export declare const FORM_ACTIVE_VALUE_ACTION_TYPE = "form.active.value";
export declare const FORM_DEACTIVATED_VALUE_ACTION_TYPE = "form.deactivated.value";
