"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var util_1 = require("../../util");
var universal_component_1 = require("../base/universal.component");
var UniversalMessage = /** @class */ (function (_super) {
    __extends(UniversalMessage, _super);
    function UniversalMessage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [23.04.2018]
     * @returns {JSX.Element}
     */
    UniversalMessage.prototype.render = function () {
        var props = this.props;
        var progress = props.progress;
        var error = props.error;
        var addChildren = false;
        return this.getMessageWrapper(progress
            ? this.getProgressLabel()
            : (error
                ? this.getErrorMessage()
                : ((addChildren = true) && (props.emptyData
                    ? this.getEmptyDataMessage()
                    : this.getEmptyMessage()))), util_1.orNull(addChildren, props.children));
    };
    /**
     * @stable [17.08.2018]
     * @returns {string}
     */
    UniversalMessage.prototype.getErrorMessage = function () {
        var props = this.props;
        var errorMessage = props.errorMessage;
        return R.isNil(errorMessage) || R.isEmpty(errorMessage)
            ? this.t(this.settings.messages.errorMessage)
            : (util_1.isPrimitive(errorMessage)
                ? this.t(errorMessage)
                : (errorMessage instanceof Error ? errorMessage.stack : JSON.stringify(errorMessage)));
    };
    /**
     * @stable [09.06.2018]
     * @returns {React.ReactNode}
     */
    UniversalMessage.prototype.getEmptyMessage = function () {
        var emptyMessage = this.props.emptyMessage;
        return util_1.isString(emptyMessage)
            ? this.t(emptyMessage)
            : (emptyMessage || this.t(this.settings.messages.emptyMessage));
    };
    /**
     * @stable [23.04.2018]
     * @returns {string}
     */
    UniversalMessage.prototype.getEmptyDataMessage = function () {
        return this.t(this.props.emptyDataMessage || this.settings.messages.emptyDataMessage);
    };
    return UniversalMessage;
}(universal_component_1.UniversalComponent));
exports.UniversalMessage = UniversalMessage;
//# sourceMappingURL=universal-message.component.js.map