import { IKeyValue } from '../../definitions.interface';
import { VueBaseComponent } from '../base/vue-index';
import { VueCreateElementFactoryT, VueNodeT } from '../../vue-definitions.interface';
import { IVueViewerStateEntity, IVueViewerTemplateMethodsEntity } from './vue-viewer.interface';
export declare class VueViewer<TVueViewerStateEntity extends IVueViewerStateEntity = IVueViewerStateEntity> extends VueBaseComponent<IKeyValue, TVueViewerStateEntity> {
    protected src: string;
    /**
     * @stable [29.11.2018]
     * @param {VueCreateElementFactoryT} createElement
     * @returns {VueNodeT}
     */
    render(createElement: VueCreateElementFactoryT): VueNodeT;
    /**
     * @stable [29.11.2018]
     * @returns {TVueViewerStateEntity}
     */
    getInitialData$(): TVueViewerStateEntity;
    /**
     * @stable [29.11.2018]
     * @returns {IVueViewerTemplateMethodsEntity}
     */
    protected getTemplateMethods(): IVueViewerTemplateMethodsEntity;
    /**
     * @stable [29.11.2018]
     * @returns {string}
     */
    protected getPopupFooterTemplate(): string;
    /**
     * @stable [29.11.2018]
     * @returns {string}
     */
    protected getPopupHeaderTemplate(): string;
    /**
     * @stable [29.11.2018]
     * @returns {string}
     */
    protected getPreviewTemplate(): string;
    /**
     * @stable [28.11.2018]
     * @returns {string}
     */
    protected getPopupBodyTemplate(): string;
    /**
     * @stable [28.11.2018]
     */
    protected onAfterOpenPopup(): void;
    /**
     * @stable [28.11.2018]
     */
    protected onAfterClosePopup(): void;
    /**
     * @stable [28.11.2018]
     */
    protected onOpenPopup(): void;
    /**
     * @stable [28.11.2018]
     */
    protected onClosePopup(): void;
}
