"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
exports.FIRST_PAGE = 1;
exports.DEFAULT_PAGE_SIZE = 50;
exports.DEFAULT_MAX_PAGE_SIZE = 100000;
exports.DEFAULT_TIME_FROM = '00:00:00';
exports.DEFAULT_TIME_TO = '23:59:59';
exports.NEW_OPTION = 'new';
exports.UNDEF = void 0;
exports.CLEAR_DIRTY_CHANGES_VALUE = exports.UNDEF;
exports.ACTION_PREFIX = '$$-RAC-';
exports.UNIVERSAL_SELECTED_ELEMENT_SELECTOR = 'rac-universal-selected-element';
/**
 * @stable [15.09.2018]
 */
exports.DAYS_OF_WEEK = [
    { id: 0, name: 'Sunday' },
    { id: 1, name: 'Monday' },
    { id: 2, name: 'Tuesday' },
    { id: 3, name: 'Wednesday' },
    { id: 4, name: 'Thursday' },
    { id: 5, name: 'Friday' },
    { id: 6, name: 'Saturday' }
];
exports.DAYS_OF_WEEK_MAP = R.mergeAll(exports.DAYS_OF_WEEK.map(function (day) {
    var _a;
    return (_a = {}, _a[day.id] = true, _a);
}));
/**
 * Core fields
 */
exports.ID_FIELD_NAME = 'id'; /* @stable [02.07.2018] */
exports.TYPE_FIELD_NAME = 'type';
exports.BODY_FIELD_NAME = 'body';
exports.AUTH_FIELD_NAME = 'auth';
exports.PARAMETERS_FIELD_NAME = 'parameters';
exports.FROM_DATE_FIELD_NAME = 'fromDate';
exports.TO_DATE_FIELD_NAME = 'toDate';
exports.FROM_TIME_FIELD_NAME = 'fromTime';
exports.TO_TIME_FIELD_NAME = 'toTime';
exports.TIME_FIELD_NAME = 'time';
exports.DATE_FIELD_NAME = 'date';
exports.FILTER_FIELD_NAME = 'filter';
exports.URL_FIELD_NAME = 'url';
exports.EFFECTOR_FIELD_NAME = 'effector'; /* @stable [28.03.2018] */
exports.PASSWORD_FIELD_NAME = 'password';
exports.EMAIL_FIELD_NAME = 'email';
exports.NAME_FIELD_NAME = 'name'; /* @stable [16.08.2018] */
exports.TITLE_FIELD_NAME = 'title';
exports.ZIP_CODE_FIELD_NAME = 'zipCode'; /* @stable [01.08.2018] */
exports.AREA_FIELD_NAME = 'area'; /* @stable [01.08.2018] */
exports.REGION_FIELD_NAME = 'region'; /* @stable [01.08.2018] */
exports.CITY_FIELD_NAME = 'city'; /* @stable [04.08.2018] */
exports.DISPLAY_MESSAGE_FIELD_NAME = 'displayMessage'; /* @stable [29.10.2018] */
exports.PROGRESS_FIELD_NAME = 'progress';
exports.UNI_CODES = {
    dash: '\u2014',
    infinity: '\u221e',
    nDash: '\u2013',
    space: '\u0020',
    noBreakSpace: '\u00a0',
    arrowRight: '\u27f6',
    crarr: '\u21b5',
    lfloor: '\u230a',
};
//# sourceMappingURL=definitions.interface.js.map