"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var di_1 = require("../di");
var util_1 = require("../util");
var CloudFileStorage = /** @class */ (function () {
    function CloudFileStorage() {
    }
    CloudFileStorage.prototype.set = function (key, value) {
        return this.process(value);
    };
    CloudFileStorage.prototype.process = function (entity) {
        var _this = this;
        return util_1.toBlobEntities.apply(void 0, entity.add.map(function (entity0) { return entity0.id; })).then(function (entities) {
            return Promise.all([
                _this.upload(entities),
                _this.clear(entity)
            ]).then(function (result) { return ({
                setFilesResults: result[0],
                removeFilesResults: result[1],
            }); });
        });
    };
    CloudFileStorage.prototype.upload = function (entities) {
        var _this = this;
        var uploadTasks = entities.map(function (entity) { return _this.cloudStorage.set(entity.id, entity.blob); });
        return Promise.all(uploadTasks);
    };
    CloudFileStorage.prototype.clear = function (entity) {
        var _this = this;
        var clearTasks = entity.remove.map(function (entity0) { return _this.cloudStorage.remove(entity0.id); });
        return Promise.all(clearTasks);
    };
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.CloudStorage),
        __metadata("design:type", Object)
    ], CloudFileStorage.prototype, "cloudStorage", void 0);
    CloudFileStorage = __decorate([
        inversify_1.injectable()
    ], CloudFileStorage);
    return CloudFileStorage;
}());
exports.CloudFileStorage = CloudFileStorage;
//# sourceMappingURL=cloud-file-storage.service.js.map