import { IEffectsAction } from 'redux-effects-promise';
import { IEntity } from '../../definitions.interface';
import { ISucceedFormMiddlewareConfig, ISucceedRelatedFormMiddlewareConfig } from './middleware.interface';
import { IApplicationStoreEntity } from '../../entities-definitions.interface';
/**
 * @stable [22.08.2018]
 * @param {ISucceedRelatedFormMiddlewareConfig<TEntity extends IEntity, TRelatedEntity extends IEntity>} config
 * @returns {IEffectsAction[]}
 */
export declare const makeSucceedRelatedFormMiddleware: <TEntity extends IEntity, TRelatedEntity extends IEntity>(config: ISucceedRelatedFormMiddlewareConfig<TEntity, TRelatedEntity, IApplicationStoreEntity<{}>>) => IEffectsAction[];
/**
 * @stable [07.07.2018]
 * @param {ISucceedFormMiddlewareConfig<TEntity extends IEntity>} config
 * @returns {IEffectsAction[]}
 */
export declare const makeSucceedFormMiddleware: <TEntity extends IEntity>(config: ISucceedFormMiddlewareConfig<TEntity, IApplicationStoreEntity<{}>>) => IEffectsAction[];
