"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var transport_reducer_interface_1 = require("./transport-reducer.interface");
function transportReducer(state, action) {
    if (state === void 0) { state = transport_reducer_interface_1.INITIAL_APPLICATION_TRANSPORT_STATE; }
    var operationId = action.data && action.data.operationId;
    switch (action.type) {
        case transport_reducer_interface_1.TRANSPORT_REQUEST_ACTION_TYPE:
            return __assign({}, state, { queue: operationId
                    ? state.queue.concat(action.data.operationId)
                    : state.queue });
        case transport_reducer_interface_1.TRANSPORT_REQUEST_CANCEL_ACTION_TYPE:
        case transport_reducer_interface_1.TRANSPORT_REQUEST_ERROR_ACTION_TYPE:
        case transport_reducer_interface_1.TRANSPORT_REQUEST_DONE_ACTION_TYPE:
            return __assign({}, state, { queue: operationId
                    ? state.queue.filter(function (item) { return item !== action.data.operationId; })
                    : state.queue });
        case transport_reducer_interface_1.TRANSPORT_DESTROY_ACTION_TYPE: {
            return __assign({}, transport_reducer_interface_1.INITIAL_APPLICATION_TRANSPORT_STATE);
        }
        case transport_reducer_interface_1.TRANSPORT_UPDATE_TOKEN_ACTION_TYPE:
            return __assign({}, state, { token: action.data.token });
        case transport_reducer_interface_1.TRANSPORT_DESTROY_TOKEN_ACTION_TYPE:
            return __assign({}, state, { token: null });
    }
    return state;
}
exports.transportReducer = transportReducer;
//# sourceMappingURL=transport.reducer.js.map