"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../util");
var dom_1 = require("./dom");
/**
 * @stable [28.06.2018]
 * @param {string[]} ids
 * @returns {Promise<IBlobEntity[]>}
 */
exports.toBlobEntities = function () {
    var ids = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        ids[_i] = arguments[_i];
    }
    return (Promise.all(util_1.orDefault(Array.isArray(ids), function () { return ids.map(function (id) { return fetch(id).then(function (r) { return r.blob(); }).then(function (blob) { return ({ id: id, blob: blob }); }); }); }, [])));
};
/**
 * @stable [28.06.2018]
 * @param {string} url
 * @param {string} fileName
 * @param {RequestInit} options
 */
exports.downloadBlob = function (url, fileName, options) {
    fetch(url, __assign({ mode: 'cors' }, options))
        .then(function (res) { return res.blob(); }).then(function (blob) { return dom_1.downloadFile(fileName, blob); });
};
//# sourceMappingURL=blob.js.map